
!TPZincMakeCallJson methodsFor: '*tropo-gemstone' stamp: 'PaulDeBruicker 04/11/2011 20:57'!
say: aString to: aPhoneNumber
	| x y json |
	self startNewSession
		ifTrue: [ 
			x := Dictionary new.
			y := Dictionary new.
			y
				at: 'message'
				put:
					((TPMessage new)
						to: aPhoneNumber;
						channel: 'VOICE';
						say: (TPSay new value: aString)).
			x at: 'tropo' put: y.
			json := x asJson.
			 TPVoiceService queueOutgoingCall: (ZnStringEntity text: json) ]! !

!TPVoiceService class methodsFor: '*tropo-gemstone' stamp: 'PaulDeBruicker 04/12/2011 16:34'!
emptyOutgoingCallQueue
	OutgoingCallQueue :=RcQueue  new.! !

!TPVoiceService class methodsFor: '*tropo-gemstone' stamp: 'PaulDeBruicker 04/12/2011 08:19'!
initialize 
"
self initialize
"
	OutgoingCallQueue:=RcQueue new.! !

!TPVoiceService class methodsFor: '*tropo-gemstone' stamp: 'PaulDeBruicker 04/12/2011 09:12'!
oldestOutgoingCall 
	^OutgoingCallQueue remove.! !

!TPVoiceService class methodsFor: '*tropo-gemstone' stamp: 'PaulDeBruicker 04/12/2011 09:10'!
queueOutgoingCall: aJson

	OutgoingCallQueue add: aJson! !

!TpZincWaitForSms classSide methodsFor: '*tropo-gemstone' stamp: 'PaulDeBruicker 04/14/2011 15:32'!
handleRequest: aRequest
	| jsonData userType from conversation stream sessionId response |
	"should only be a POST from tropo"
	self halt.
	aRequest method == #POST
		ifTrue: [ 
			stream := aRequest entity readStream.	"self halt."
			jsonData := JSJsonParser readFrom: stream.
			"self halt."
			(jsonData at: 'session') notNil
				ifTrue: [ 
					from := (jsonData at: 'session') at: 'from'.
					sessionId := (jsonData at: 'session') at: 'id'.
					userType := (jsonData at: 'session') at: 'userType' ]
				ifFalse: [ sessionId := (jsonData at: 'result') at: 'sessionId' ].
			"	self halt."
			conversation := from isNil
				ifTrue: [ TPSmsConversation findById: sessionId ]
				ifFalse: [ (TPSmsConversation findByFrom: from) id: sessionId ].
			conversation requests add: jsonData.
			response := userType = 'NONE'
				ifTrue: [ TPSmsService oldestOutgoingMessage ]
				ifFalse: [ TPSmsService findNextResponseFor: conversation. ].
			conversation responses add: response.
		"	self halt."
			conversation from isNil
				ifFalse: [conversation printLastMessageToTranscipt].
			conversation inspect ].
	"	self halt."
	^ ZnResponse ok: response! !

!TpZincWaitForSms classSide methodsFor: '*tropo-gemstone' stamp: 'PaulDeBruicker 04/14/2011 15:44'!
startDefaultOn: aPort

self stopDefault.

self httpService: (ZnServer defaultOn: aPort).
self httpService delegate: self.
self httpService start.
[true] whileTrue: [ (Delay forSeconds: 10) wait ].! !

!TpZincWaitForSms classSide methodsFor: '*tropo-gemstone' stamp: 'PaulDeBruicker 04/14/2011 15:37'!
stopDefault
	ZnServer stopDefault.! !

!TpZincWaitForSms classSide methodsFor: '*tropo-gemstone' stamp: 'PaulDeBruicker 04/12/2011 08:56'!
stopOn: aPortNumber
System abortTransaction.
ZnServer defaultServerClass allInstances do: [:eachService | eachService port = aPortNumber ifTrue:[eachService stop]].! !

!TPZincWaitForCall classSide methodsFor: '*tropo-gemstone' stamp: 'PaulDeBruicker 04/12/2011 11:22'!
handleRequest: aRequest
	| jsonData userType from conversation stream sessionId response |
	"should only be a POST from tropo"
"	self halt."
	aRequest method == #POST
		ifTrue: [ 
			stream := aRequest entity readStream.	
			jsonData := JSJsonParser readFrom: stream.
	
			(jsonData at: 'session') notNil
				ifTrue: [ 
					from := (jsonData at: 'session') at: 'from'.
					sessionId := (jsonData at: 'session') at: 'id'.
					userType := (jsonData at: 'session') at: 'userType' ]
				ifFalse: [ sessionId := (jsonData at: 'result') at: 'sessionId' ].
			"	self halt."
			conversation := from isNil
				ifTrue: [ TPVoiceConversation findById: sessionId ]
				ifFalse: [ (TPVoiceConversation findByFrom: from) id: sessionId ].
			conversation requests add: jsonData.
			response := userType = 'NONE'
				ifTrue: [ TPVoiceService oldestOutgoingCall ]
				ifFalse: [ TPVoiceService findNextResponseFor: conversation. ].
			conversation responses add: response.
			"conversation printLastMessageToTranscipt."
			conversation inspect ].
		"self halt."
	^ ZnResponse ok: response! !

!TPZincWaitForCall classSide methodsFor: '*tropo-gemstone' stamp: 'PaulDeBruicker 04/12/2011 11:22'!
stopOn: aPortNumber
System abortTransaction.
ZnServer defaultServerClass allInstances do: [:eachService | eachService port = aPortNumber ifTrue:[eachService stop]].! !

!TPZincSendSmsJson methodsFor: '*tropo-gemstone' stamp: 'PaulDeBruicker 04/11/2011 20:58'!
sendSms: aString to: aPhoneNumber
	| x y json |
	self startNewSession
		ifTrue: [ 
			x := Dictionary new.
			y := Dictionary new.
			y
				at: 'message'
				put:
					((TPMessage new)
						network: 'SMS';
						to: aPhoneNumber;
						channel: 'TEXT';
						say: (TPSay new value: aString)).
			x at: 'tropo' put: y.
			json := x asJson.
			 TPSmsService queueOutgoingMessage: (ZnStringEntity text: json) ]! !

!TPSmsService class methodsFor: '*tropo-gemstone' stamp: 'PaulDeBruicker 04/12/2011 16:34'!
emptyOutgoingMessageQueue
	OutgoingMessageQueue :=RcQueue  new.! !

!TPSmsService class methodsFor: '*tropo-gemstone' stamp: 'PaulDeBruicker 04/12/2011 08:19'!
initialize 
"
self initialize
"
	OutgoingMessageQueue:=RcQueue new.! !

!TPSmsService class methodsFor: '*tropo-gemstone' stamp: 'PaulDeBruicker 04/12/2011 09:12'!
oldestOutgoingMessage 
	^OutgoingMessageQueue remove.! !

!TPSmsService class methodsFor: '*tropo-gemstone' stamp: 'PaulDeBruicker 04/12/2011 09:10'!
queueOutgoingMessage: aJson

	OutgoingMessageQueue add: aJson.! !
TPSmsService initialize!
TPVoiceService initialize!
